# sb::Plugin::TbLinkLookup
# 
# == original by Fuco / published on 2005-10-05 ====
# == modified by T.Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ ==

# ======================================
package sb::Plugin::TbLinkLookup;
# --------------------------------------
# // configuration for inheritance / dependancy
use sb::Plugin ();
use sb::Receipt ();
use HTTP::Request ();
# --------------------------------------
# // initialization for plugin
sb::Plugin->register_plugin(
	'lang' => {
		'ja' => 'euc',
		'en' => 'ascii',
	},
	'text' => {
		'type'    => 'receipt',
		'name'    => 'Trackback Link Lookup',
		'text'    => 'Ban the trackback which has no link to me.',
		'author'  => 'takkyun',
		'detail'  => 'http://serenebach.net/',
		'version' => '0.01',
	},
	'file' => undef,
);
sb::Plugin->register_extra_module(
	'type' => 'receipt',
	'callback' => \&tblinklookup_issue,
);
# --------------------------------------
# // plugin routine
sub tblinklookup_issue
{
	my $self  = shift;
	my $entry = shift; # entry object : sb::Data::Entry
	my $type  = shift; # 'tb' or 'com'
	my $obj   = shift; # data hash reference (not sb::Data::Object)
	return 0 if ($type ne 'tb');
	my $ua = sb::App->init_agent;
	my $res = $ua->request(HTTP::Request->new(GET => $obj->{'url'}));
	my $ok = $res->is_success && do {
		my $url = sb::Config->get->value('conf_srv_base');
		$res->content =~ m/\Q$url\E/;
	};
	return 1 if (!$ok);
	return 0;
}
1;
__END__
# This script is derived from 'tb-link-lookup.pl', written by 
# Naoya Ito / Tatsuhiko Miyagawa for Movable Type.
# ----
# Original script (TbLinkLookup.pm) is written by Fuco.
